// vim: set undofile:
// Program: 01_counting

#include <vector>
#include <iostream>
#include <algorithm>
#include <iterator>
#include <string>


bool is_selected(const std::string &item)
{
    return item[0] == '*';
}

int main(int argc, char *argv[])
{
    std::vector<std::string> items {
            "aardvark",
            "compunctious",
            "**congratulations**",
            "contrafribblarity",
            "contrary",
            "dictionary",
            "**interphrastical**",
            "**patronise**",
            "**pericombobulation**",
            "phrasmotic",
            "**syllables**"
        };

    // remove_if samo pomera stavke koje ne treba izbrisati na pocetak
    // kolekcije, a ostale elemente ostavlja u neodredjenom stanju.
    // erase brise te elemente.
    items.erase(
            std::remove_if(std::begin(items), std::end(items),
                           [] (const auto &item) { return !is_selected(item); }),
            std::end(items)
        );

    std::copy(std::begin(items), std::end(items),
              std::ostream_iterator<std::string>(std::cout, "\n"));

    // alternativno std::copy_if

    return 0;
}
